;Tmenu (236 bytes)
;This subroutine is able to use "BASIC" style menu.
;You can choose using "[up] and [down] and [Enter]" or "[1] to [7]".
;
;Inputs   : B = number of items, HL = menu datas
;Outputs  : displays BASIC style menu
;Destroies: all
;
;menu datas formats:
;menus:	.db "Menu Title",0
;	.db "Menu Item1",0
;	.dw address1
;	.db "Menu Item2",0
;	.dw address2
;	.db "Menu Item3",0
;	.dw address3
;
;	These subroutine(e.g. address1, address2, address3...) called needs to terminate "ret".
;	After subroutine was called, returns to next address of "call Tmenu".
;	If you want to use "jp" or "jr" when the subroutine terminate, 
;	please remove left side's semicolon in the 131th line.
;
;	Written by YUKI. [http://www.ticalc.org/archives/files/authors/70/7071.html]
;
#ifndef bcall(xxxx)
#define bcall(xxxx) rst 28h \ .dw xxxx
#endif
Tmenu:	push hl
	push hl
	push bc
	set 3,(iy+5)
	bcall(4540h)
	bcall(4558h)
	pop bc
	pop hl
	bcall(450Ah)
	res 3,(iy+5)
	ld c,0
Tmenu1:	inc c
	push hl
	bcall(452Eh)
	ld hl,Tmenudb
	ld a,48
	add a,c
	ld (hl),a
	bcall(450Ah)
	pop hl
	bcall(450Ah)
	inc hl
	inc hl
	djnz Tmenu1
	pop hl
	ld b,c

	ld c,1
	call TmenuInv
Tmenu2:	push hl
	push bc
	bcall(4018h)
	pop bc
	pop hl
	ld d,0
	cp 04h
	jp z,Tk_up
	cp 01h
	jp z,Tk_down
	cp 22h
	jp z,Tk_1
	cp 1Ah
	jp z,Tk_2
	cp 12h
	jp z,Tk_3
	cp 23h
	jp z,Tk_4
	cp 1Bh
	jp z,Tk_5
	cp 13h
	jp z,Tk_6
	cp 24h
	jp z,Tk_7
	cp 09h
	jp z,Tk_enter
	cp 36h
	jp z,Tk_enter
	jp Tmenu2

Tk_up:	ld a,c
	cp 1
	jp z,Tmenu2
	ld e,0
	call TmenuInv
	dec c
	inc e
	call TmenuInv
	jp Tmenu2

Tk_down:ld a,c
	cp b
	jp z,Tmenu2
	ld e,0
	call TmenuInv
	inc c
	inc e
	call TmenuInv
	jp Tmenu2

Tk_7:	inc d
Tk_6:	inc d
Tk_5:	inc d
Tk_4:	inc d
Tk_3:	inc d
Tk_2:	inc d
Tk_1:	
	ld a,d
	cp b
	jp nc,Tmenu2
	inc a
	ld c,a
Tk_enter:
	ld d,c
	ld bc,$FFFF
	xor a
	cpir
Tmenu3:	ld bc,$FFFF
	xor a
	cpir
	dec d
	jp nz,Tmenu3
	bcall(4009h)

;	pop af ;If you want to use jp or jr, please remove left side's semicolon

	push hl
	bcall(4558h)
	bcall(4540h)
	ret

TmenuInv:
	push hl
	xor a
	ld (844Ch),a
	ld a,c
	ld (844Bh),a
	ld a,48
	add a,c
	ld hl,Tmenudb
	ld (hl),a
	inc e
	dec e
	jp z,TmenuInv1
	set 3,(iy+5)
TmenuInv1:bcall(450Ah)
	res 3,(iy+5)
	pop hl
	ret

Tmenudb:
	.db 0,":",0
